#version 420 core

in vec2 texCoord;

layout(binding = 0) uniform sampler2D sceneTexture;

out vec4 fResult;

uniform int numGhosts = 3;

void main()
{
	vec2 texCoordFlip = -texCoord + vec2(1.0);
	vec4 lensflareColor = vec4(0);

	float brightTexture = 0.0;
	for(int i = -1; i < numGhosts; i++)
    {
		vec2 deltaTexCoord = 0.75*(texCoord-texCoordFlip)*0.25;
		lensflareColor.x += max( (texture(sceneTexture, fract(texCoordFlip + deltaTexCoord * float(i)*1.01) ).y - 0.96) , 0);
		lensflareColor.y += max( (texture(sceneTexture, fract(texCoordFlip + deltaTexCoord * float(i)*1.02) ).y - 0.96) , 0);
		lensflareColor.z += max( (texture(sceneTexture, fract(texCoordFlip + deltaTexCoord * float(i)*1.03) ).z - 0.96) , 0);
	}
	fResult = vec4( (lensflareColor.x *1.0 + texture(sceneTexture, texCoord).x), 
					(lensflareColor.y *1.0 + texture(sceneTexture, texCoord).y),
					(lensflareColor.z *1.0 + texture(sceneTexture, texCoord).z),  1);
}